import _classCallCheck from "babel-runtime/helpers/classCallCheck";

var PubSub = function () {
  function PubSub() {
    _classCallCheck(this, PubSub);

    this.subscribers = [];
    this.lastSubscriberId = 0;
  }

  PubSub.prototype.subscribe = function subscribe(fn) {
    this.lastSubscriberId = this.lastSubscriberId + 1;
    this.subscribers.push({
      callback: fn,
      id: this.lastSubscriberId
    });
    return this.lastSubscriberId;
  };

  PubSub.prototype.unsubscribe = function unsubscribe(id) {
    if (id) {
      for (var i = this.subscribers.length - 1; i >= 0; i -= 1) {
        if (this.subscribers[i].id === id) {
          this.subscribers.splice(i, 1);
          return true;
        }
      }
    }
    return false;
  };

  PubSub.prototype.unsubscribeAll = function unsubscribeAll() {
    this.subscribers = [];
    this.lastSubscriberId = 0;
  };

  PubSub.prototype.publish = function publish() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    this.subscribers.forEach(function (subscriber) {
      subscriber.callback.apply(null, args);
    });
  };

  return PubSub;
}();

export default PubSub;