import { validators } from './validators';

var requiredValidator = function requiredValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var errors = [];
  if (!validators.required.check(value)) {
    errors.push(validators.required.message);
  }
  return errors;
};

var emailValidator = function emailValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var errors = [];
  if (!validators.email.check(value)) {
    errors.push(validators.email.message);
  }
  return errors;
};

var equalValidator = function equalValidator() {
  var value1 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var value2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  var errors = [];
  if (!validators.equal.check(value1, value2)) {
    errors.push(validators.equal.message);
  }
  return errors;
};

var regexValidator = function regexValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var regex = arguments[1];

  var errors = [];
  if (!validators.regex.check(regex, value)) {
    errors.push(validators.regex.message);
  }
  return errors;
};

var passwordValidator = function passwordValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var errors = [];
  if (!validators.password.check(value)) {
    errors.push(validators.password.message);
  }
  return errors;
};

var minLengthValidator = function minLengthValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var len = arguments[1];

  var errors = [];
  if (!validators.minLength.check(value, len)) {
    errors.push(validators.minLength.message(len));
  }
  return errors;
};

var maxLengthValidator = function maxLengthValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var len = arguments[1];

  var errors = [];
  if (!validators.maxLength.check(value, len)) {
    errors.push(validators.maxLength.message(len));
  }
  return errors;
};

export { validators, requiredValidator, emailValidator, equalValidator, regexValidator, passwordValidator, minLengthValidator, maxLengthValidator };